/***************************************************************************************
*									KoSi_Gen.c
*
* WinAVR Vers.:			
*
* AVR-Studio Version:	5
*
* Autor: 				Rick
*
* Getestet:						
*
* Letzte nderung:		
*
***************************************************************************************/

#include "KoSi_Gen.h"

// ********************************** MAIN *******************************************

int main(void)
{
    
	adc_init();
	timer1_init();
	lcd_init(LCD_DISP_ON);
	//uart_init(UART_BAUD_SELECT(UART_BAUD_RATE,XTAL));
		
	MCUCSR |= (1<<JTD);		// JTAG aus
	MCUCSR |= (1<<JTD);
	
	DDRA = 0x00;		// PORTA Pin0 bis 6 fr Testzwecke nicht bentzt ->als Eingang + Pull Up EIN
	PORTA |= (1<<PA0) | (1<<PA1) | (1<<PA2) | (1<<PA3)| (1<<PA4) | (1<<PA5) | (1<<PA6);
	PORTA &= ~(1<<PA7); // PA7 fr Tasten auf high-z


	DDRC = 0xFF;		// PORTC als Ausgang (LEDs)
	PORTC = 0x00;		// Alle LEDs ein (fr Funktionstest)
	
	DDRD |= (1<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5)| (1<<PD6) | (1<<PD7);		// PORTD Pin 2 bis Pin7 als Eingang ,da unbentzt
	PORTD |= (1<<PD2) | (1<<PD3) | (1<<PD4) | (1<<PD5)| (1<<PD6) | (1<<PD7);	// Interne Pull-Up ein
																				// PD0 + PD1 fr RS232
	for(uint8_t i=0 ; i<= 100 ; i++)  // ca. 1,6 sec warten
		_delay_ms(16);
	
	PORTC = 0xFF;		// Alle LEDS aus
	
	sei();				// globale Interrupts ein
	

//********************************* HAUPTSCHLEIFE *************************************	
	while(1)		
    {
		
		if(second_puls == 1)		// toggle LED7
			PORTC ^= (1<<PC7);
		
		
		
		
		//***************************** TASTENABFRAGE *********************************
			 
		if(button_read_puls == 2)			// 8msec vergangen
			button1 = read_button();		// Tasten auslesen und speichern
			
		if(button_read_puls == 4)			// weitere 8msec vergangen
			{
				button2 = read_button();	// Tasten auslesen und speichern
				
				if( button1 == button2 != 0 )		// wenn Tastennummer 1 = Tastennummer 2 und ungleich 0
					if(++equal_counter == 255)		// Zhlvariable fr bereinstimmung +1
						equal_counter = 0;			// Schutz vor berlauf
			
			
				if( (button1 != button2) && (button2 == 0) ) // wenn Taste wieder losgelassen
				{
			
		
					if( (equal_counter >= 5) && (equal_counter < 100) )	// kurzer Tastendruck 
					{
						button = button1;		// Tastennummer sichern
						equal_counter = 0;		// Zhler zurcksetzen
					}		
		
					if( (equal_counter >= 100) && (equal_counter <= 200)  )	// langer Tastendruck 
					{	
						button = button1 +10;		// neue Tastennummer fr 2te Funktion
						equal_counter = 0;			// Zhler zurcksetzen
					}		
				}			
										
			switch ( button )				// Handlung zuweisen
			{
				char string [5];
				
				case 0:	
					break;					// keine Taste gedrckt nix machen
		
				case 1:						// Taste 1
					lcd_clrscr();
					lcd_puts("Taste1");						
					PORTC ^= (1<<PC0);
					button = 0;				// erkannte Taste zurcksetzen
					break;
						
					 
				case 2:
					lcd_clrscr();
					lcd_puts("Taste2");		// Taste 2
					PORTC ^= (1<<PC1);
					button = 0;				// erkannte Taste zurcksetzen
					break;
		
				case 3:	
					lcd_clrscr();
					lcd_puts("Taste3");		// Taste 3
					PORTC ^= (1<<PC2);
					button = 0;				// erkannte Taste zurcksetzen
					break;
		
				case 4:	
					lcd_clrscr();
					lcd_puts("Taste4");		// Taste 4
					PORTC ^= (1<<PC3);
					button = 0;				// erkannte Taste zurcksetzen
					break;
		
				case 5:	
					lcd_clrscr();
					lcd_puts("Taste5");		// Taste 5
					PORTC ^= (1<<PC4);
					button = 0;				// erkannte Taste zurcksetzen
					break;
		
				case 99:						// FEHLER
								
					lcd_clrscr();
					lcd_puts("ERROR_BUTTON");			// Fehlerausgabe: Tastenabfrage Fehler!	
					lcd_gotoxy(0,1);
					lcd_puts("ADC:");
					itoa (adc_value_button, string, 10);
					lcd_puts(string);
					break;
		
				default:
					break;
			}			
		}									
		
		
		//************************** ANALOGWERTE AUSLESEN **********************	
		/*
		voltage_source = read_voltage_source();
		voltage_electrodes = read_voltage_electrodes();
		current_electrodes = read_current_electrodes();
		*/
		
		//************************ AUSGNGE SETZEN *************************************
		
		//******** Gert AUS
		/*
		if(gen_on == 0)
		{
			PORT_MAIN_SWITCH &= ~(1<<PIN_MAIN_SWITCH);		// Gert ausschalten
			PORT_AC_SWITCH &= ~(1<<PIN_AC_SWITCH);			// AC Ausgang auf 0
		}
		
		//******** Gert EIN *** DC-Mode
		
		if( (gen_on == 1) && (current_mode == 0) )			// Gert EIN, DC-Mode
			PORT_MAIN_SWITCH |= (1<<PIN_MAIN_SWITCH);		// Gert EIN
			
		
		//******** Gert EIN *** AC-Mode
		
		if( (gen_on == 1) && (current_mode == 1) )			// Gert EIN, AC-Mode
		{
			PORT_MAIN_SWITCH |= (1<<PIN_MAIN_SWITCH);		// Gert EIN
			
			if(second_puls == 1)
				ac_time++;
			
			if(ac_time == ac_period)
			{
				PORT_AC_SWITCH ^= (1<<PIN_AC_SWITCH);		// AC-Ausgang toggeln
				ac_time = 0;								// Zhler rcksetzen
			}
		}			
			
		*/	
				
		//************************** COUNTDOWN ***************************************
		/*
		if (gen_on && second_puls)		// wenn Gert eingeschaltet und Sekundenpuls da
		{
			second_countdown--;				// Sekunde -1
			
			if( second_countdown == -1)		// wenn Sekunden abgelaufen
			{
				
				if( (minute_countdown > 0) || (hour_countdown > 0) )
				{											// wenn Restzeit vorhanden	
					second_countdown = 59;					// Sekunden wieder auf 59
					minute_countdown = minute_countdown -1;		// Minuten -1
				}
			
				else if( (minute_countdown == -1) && (hour_countdown > 0) )	
				{							// wenn Minuten abgelaufen und Restzeit da
					minute_countdown = 59;						// Minuten wieder auf 59
					hour_countdown = hour_countdown -1;			// Stunden -1
				}
			
			
				else
					gen_on = 0;									// Gert ausschalten
			}
		}		
		
		*/
	
		
		
		
		
		//************************** DISPLAY AUSGABE ***************************
		
		/*if(second_puls == 0)			// Display-Ausgabe nur 1x pro Sekunde
			display_lcd_page1();		// Anzeigeseite 1 am LCD ausgeben
		
		*/
	
	
	
	
	 
	    
	}    
}